unit BerechnungsreihenfolgeGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Grids, ValEdit, NeuronaleNetze, Neuronen;

type
  TBerechnungsreihenfolgeForm = class(TForm)
    ReihenfolgeListbox: TListBox;
    nachObenButton: TButton;
    nachUntenButton: TButton;
    AnDenAnfangButton: TButton;
    AnDasEndeButton: TButton;
    GroupBox1: TGroupBox;
    EntsprechendEbenenButton: TButton;
    EntsprechendKennungsreihenfolge: TButton;
    Button1: TButton;
    GroupBox2: TGroupBox;
    UebernehmeReihenfolgeButton: TButton;
    procedure ListBox2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure nachObenButtonClick(Sender: TObject);
    procedure nachUntenButtonClick(Sender: TObject);
    procedure AnDenAnfangButtonClick(Sender: TObject);
    procedure AnDasEndeButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure UebernehmeReihenfolgeButtonClick(Sender: TObject);
    procedure EntsprechendEbenenButtonClick(Sender: TObject);
    procedure EntsprechendKennungsreihenfolgeClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  BerechnungsreihenfolgeForm: TBerechnungsreihenfolgeForm;

implementation

{$R *.dfm}

procedure TBerechnungsreihenfolgeForm.ListBox2DragOver(Sender,
  Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
    if (Source is TListBox) then Accept := True;

end;

procedure TBerechnungsreihenfolgeForm.ListBox2DragDrop(Sender,
  Source: TObject; X, Y: Integer);
begin

    if (Source is TListBox) and (Sender is TListBox) then
    begin
      {Element in 2. LB einfuegen
       Sender ist der 'Empfaenger', Source halt die Quelle}
      TListBox(Sender).Items.Add(TListBox(Source).Items.Strings[TListBox
            (Source).ItemIndex]);
      {Element aus 1. LB loeschen}
      //TListBox(Source).Items.Delete(TListBox(Source).ItemIndex);
    end;

end;


procedure TBerechnungsreihenfolgeForm.nachObenButtonClick(Sender: TObject);
var akt:integer;
begin
try
akt:=ReihenfolgeListbox.ItemIndex;
ReihenfolgeListbox.Items.Move(akt,akt-1);
ReihenfolgeListbox.ItemIndex:=akt-1;
except
end;
end;

procedure TBerechnungsreihenfolgeForm.nachUntenButtonClick(Sender: TObject);
var akt:integer;
begin
try
akt:=ReihenfolgeListbox.ItemIndex;
ReihenfolgeListbox.Items.Move(akt,akt+1);
ReihenfolgeListbox.ItemIndex:=akt+1;
except
end;
end;

procedure TBerechnungsreihenfolgeForm.AnDenAnfangButtonClick(
  Sender: TObject);
var akt:integer;
begin
try
akt:=ReihenfolgeListbox.ItemIndex;
ReihenfolgeListbox.Items.Move(akt, 0);
ReihenfolgeListbox.ItemIndex:=0;
except
end;
end;

procedure TBerechnungsreihenfolgeForm.AnDasEndeButtonClick(
  Sender: TObject);
var akt:integer;
begin
try
akt:=ReihenfolgeListbox.ItemIndex;
ReihenfolgeListbox.Items.Move(akt, ReihenfolgeListbox.Count-1);
ReihenfolgeListbox.ItemIndex:=ReihenfolgeListbox.Count-1;
except
end;
end;

procedure TBerechnungsreihenfolgeForm.FormActivate(Sender: TObject);
var i: Integer;
begin
ReihenfolgeListbox.Items.Clear;{erstmal leeren}
try
//if myNeuronalesNetz.getLengthBerechnungsreihenfolgeArray=0 then myNeuronalesnetz.BerechnungsreihenfolgeWieTim; Wre das berhaupt gut?
begin
  for i:=0 to myNeuronalesNetz.getlengthBerechnungsreihenfolgeArray-1 do
    ReihenfolgeListbox.Items.AddObject('Neuron Nr. '+InttoStr(myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i).getKennung), myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i));
end;
except
end;
end;

procedure TBerechnungsreihenfolgeForm.Button1Click(Sender: TObject);
var i:integer;
begin
try
myNeuronalesNetz.BerechnungsreihenfolgeWieTim;
ReihenfolgeListbox.Items.Clear;{erstmal leeren}
  for i:=0 to myNeuronalesNetz.getlengthBerechnungsreihenfolgeArray-1 do
    ReihenfolgeListbox.Items.AddObject('Neuron Nr. '+InttoStr(myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i).getKennung), myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i));
except
end;
end;

procedure TBerechnungsreihenfolgeForm.UebernehmeReihenfolgeButtonClick(Sender: TObject);
var i:integer; zwN: Neuron;
begin
for i:=0 to ReihenfolgeListbox.Count-1 do
  begin
  zwN:=Neuron(ReihenfolgeListbox.Items.Objects[i]);
  myNeuronalesNetz.setNeuronInBerechnungsreihenfolgearray(i,zwN);
  end;
end;

procedure TBerechnungsreihenfolgeForm.EntsprechendEbenenButtonClick(
  Sender: TObject);
var i:integer;
begin
try
myNeuronalesNetz.BerechnungsreihenfolgeWieEbene;
ReihenfolgeListbox.Items.Clear;{erstmal leeren}
  for i:=0 to myNeuronalesNetz.getlengthBerechnungsreihenfolgeArray-1 do
    ReihenfolgeListbox.Items.AddObject('Neuron Nr. '+InttoStr(myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i).getKennung), myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i));
except
end;
end;

procedure TBerechnungsreihenfolgeForm.EntsprechendKennungsreihenfolgeClick(
  Sender: TObject);
var i:integer;
begin
try
myNeuronalesNetz.BerechnungsreihenfolgeWieKennung;
ReihenfolgeListbox.Items.Clear;{erstmal leeren}
  for i:=0 to myNeuronalesNetz.getlengthBerechnungsreihenfolgeArray-1 do
    ReihenfolgeListbox.Items.AddObject('Neuron Nr. '+InttoStr(myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i).getKennung), myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i));
except
end;
end;

end.
