unit FeedForwardNetzErstellenGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, NeuronaleNetze, Neuronen, math;

type
  TFFNerstForm = class(TForm)
    AnzahlenGroup: TGroupBox;
    TypGroup: TRadioGroup;
    ErstelleNetzButton: TButton;
    EbenenListBox: TListBox;
    NeueEbeneButton: TButton;
    ResetButton: TButton;
    GewichteGroup: TRadioGroup;
    GewichteBox: TGroupBox;
    InitGewichtEdit: TEdit;
    InitGewichtFeld: TLabel;
    Label1: TLabel;
    BFSCB: TCheckBox;
    procedure NeueEbeneButtonClick(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure ErstelleNetzButtonClick(Sender: TObject);
    procedure ErstelleDasFFN();
    procedure GewichteGroupClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FFNerstForm: TFFNerstForm;

implementation

{$R *.dfm}

procedure TFFNerstForm.NeueEbeneButtonClick(Sender: TObject);
var
 zw: Integer;
begin
try
  zw := StrToInt(inputbox('Eingabe','Geben Sie die Anzahl der Neuronen auf der anzulegenden Ebene an!',''));
//  EbenenListBox.Items.Add(IntToStr(zw)); Besser s.u.
  EbenenListBox.Items.AddObject(IntToStr(zw),TObject(zw));
except
  MessageDlg('Bitte geben Sie nur Integerwerte ein!', mtError, [mbOk], 0);
end;


end;

procedure TFFNerstForm.ResetButtonClick(Sender: TObject);
begin
Ebenenlistbox.Items.Clear;
end;

procedure TFFNerstForm.ErstelleNetzButtonClick(Sender: TObject);
var allesGut: boolean;
begin
// Ist alles gut eingestellt worden?
allesGut:=true;
if EbenenListBox.Items.Count=0 then allesGut:=false;
if GewichteGroup.ItemIndex=-1 then allesGut:=false;
if TypGroup.ItemIndex=-1 then allesGut:=false;
if allesGut then
  begin
    ErstelleDasFFN();
    if BFSCB.checked then myNeuronalesNetz.BerechnungsreihenfolgeWieTim;
  end
else
  MessageDlg('Es ist nicht alles richtig eingestellt!', mtError, [mbOk], 0);
end;

procedure TFFNerstForm.ErstelleDasFFN();
var
  li, re: Integer; // geben die letzte Aktuelle Ebene im Neuronenarray an (von li bis re)
  h,i,j: Integer;
  anzahlNaechsteSchicht: Integer;
  aktuelleSchicht: Integer;
  w: Real;
  nN: Neuron;
  wLi,wRe: Integer;
begin
w:=1;
// Hier wird das eigentlich Netz entsprechend Voreinstellungen in der vorhergehenden Methode erstellt.
myNeuronalesNetz:=NeuronalesNetz.create();
// li, re, aktuelleSchicht Initialisieren:
li:=0; re:=0; aktuelleSchicht:=0;
wLi:=-1000; wRe:=1000;
if GewichteGroup.ItemIndex=1 then begin wLi:=round((StrToFloat(InitGewichtEdit.Text))*1000); wRe:=round((StrToFloat(InitGewichtEdit.Text))*1000); end;
for h:=0 to EbenenListBox.Count-1 do
  begin
  // Frage: Wieviele Neuronen sind auf der nchsten Schicht?
  anzahlNaechsteSchicht:= Integer(EbenenListBox.Items.Objects[h]);
  for i:=1 to anzahlNaechsteSchicht do
    begin
    Randomize;
      nN:=myNeuronalesNetz.makeNeuron(myNeuronalesNetz.getNeuronFromNeuronenarray(li),h+1,RandomRange(wLi,wRe)/1000);
        for j:=li+1 to re do
          begin
            myNeuronalesNetz.makeEdge(myNeuronalesNetz.getNeuronFromNeuronenarray(j),nN,RandomRange(wLi,wRe)/1000);
          end;
    end;
    li:=re+1;
    re:=myNeuronalesNetz.getlengthNeuronenArray-1;
  end;
// ist dat ding bi oder hetero
if TypGroup.ItemIndex=0 then
    for i:=0 to myNeuronalesNetz.getlengthNeuronenArray-1 do
      myNeuronalesNetz.getNeuronFromNeuronenarray(i).setAktFkt(4);
if TypGroup.ItemIndex=1 then
    for i:=0 to myNeuronalesNetz.getlengthNeuronenArray-1 do
      myNeuronalesNetz.getNeuronFromNeuronenarray(i).setAktFkt(3);

//Aber nicht die Eingabeneuronen, diese haben IMMER AktFkt: id:
for i:=0 to myNeuronalesNetz.getStartNeuron.getLetzterNachfolger do
  myNeuronalesNetz.getStartNeuron.getNachfolger(i).setAktFkt(0);

end;




procedure TFFNerstForm.GewichteGroupClick(Sender: TObject);
begin
if GewichteGroup.ItemIndex=0 then begin InitGewichtEdit.Enabled:=false; InitGewichtFeld.Enabled:=false end
else if GewichteGroup.ItemIndex=1 then begin InitGewichtEdit.Enabled:=true; InitGewichtFeld.Enabled:=true end;
end;

end.

