unit Funktionen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

  type
    Funktion=class
  public
    class function aufruf(x: real; typ: Integer):real;
    class function id(x: real): real;
    class function lin(x: real): real;
    class function sgn(x: real): real;
    class function sgd(x: real): real;
    class function tanh(x: real): real;
    // Ableitung
    class function sgdI(x: real): real;
    class function tanhI(x: real): real;
end;
implementation

class function Funktion.id(x: real): real;
begin
  result:=x;
end;

class function Funktion.lin(x: real): real;
begin
  if x<0 then result:=0 else if x>0 then result:=1 else result:=x;
end;

class function Funktion.sgn(x: real): real;
begin
  if x<0 then result:=-1 else result:=1;
end;

class function Funktion.sgd(x: real): real;
begin
  result:=1/(1+exp(-x));
end;

class function Funktion.tanh(x: real): real;
begin
  result:=(exp(x)-exp(-x))/(exp(x)+exp(-x));
end;

class function Funktion.sgdI(x: real): real;
begin
  result:=exp(-x)/(sqr(1+exp(-x)));
end;

class function Funktion.tanhI(x: real): real;
begin
  result:=1-sqr(tanh(x));
end;



class function Funktion.aufruf(x: real; typ: Integer):real;
begin
  case typ of
    0:    result:=x;        // Identitt
    1:    result:=lin(x);   // Linear bis Sttigung
    2:    result:=sgn(x);   // Signumfunktion
    3:    result:=sgd(x);   // Logistische Funtion
    4:    result:=tanh(x);  // Tangens Hyperbolicus
    100:  result:=0;        // DUMMY
    103:  result:=sgdI(x);  // Ableitung logistische Funktion
    104:  result:=tanhI(x); // Ableitung Tangens Hyperbolicus

  else
    Showmessage('Die Funktion existiert nicht!');
    result:=-9999;
  end;
end;



end.
