unit GraphGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, XPMan, ComCtrls, ColorGrd, Neuronen, Math,
  ToolWin, NeuronaleNetze, Menus, ExtDlgs, Spin;

type
  TGraphForm = class(TForm)
    GraphScrollBox: TScrollBox;
    GraphImage: TImage;
    GraphControlPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    obererRandfeld: TEdit;
    LinkerRandfeld: TEdit;
    Abstandfeld: TEdit;
    Label4: TLabel;
    Neuronenradiusfeld: TEdit;
    MainMenu1: TMainMenu;
    Aktualisiere1: TMenuItem;
    Speichere1: TMenuItem;
    GraphSavePicDialog: TSavePictureDialog;
    ZeichenreihenfolgeGroup: TRadioGroup;
    szCB: TCheckBox;
    procedure FormPaint(Sender: TObject);
    procedure takeitClick(Sender: TObject);
    procedure Aktualisiere1Click(Sender: TObject);
    procedure Speichere1Click(Sender: TObject);
  private
    Abstand: integer;
    NeuronRadius: integer;
    linkerRand: integer;
    obererRand: integer;
    yZaehler: Array of Integer;
    Positionenspeicher: Array of Array of Integer; // Drei Zeilen: 1. Neuronenkennung; 2. x pos 3. y pos
    Speicherzaehler: Integer;
    zuletztGemaltesNetz: NeuronalesNetz;
    { Private-Deklarationen }
  public
      constructor init(tiefe: integer);
      procedure Kreis(x,y, nr: integer);
      procedure malNeuron(thatNeuron: Neuron);
      procedure malKante(von, bis: Neuron);
      procedure malNetz();
    { Public-Deklarationen }
  end;

var
  GraphForm: TGraphForm;

implementation
{$R *.dfm}

constructor TGraphForm.init(tiefe: integer);
var i:integer;
begin
GraphImage.Picture:=nil;
if Abstand=0 then Abstand:=50;
if NeuronRadius=0 then NeuronRadius:=10;
if linkerrand=0 then linkerRand:=100;
if obererrand=0 then obererRand:=100;
if ZeichenreihenfolgeGroup.ItemIndex=-1 then ZeichenreihenfolgeGroup.ItemIndex:=0;
Speicherzaehler:=0;
SetLength(yZaehler, tiefe+3);
for i:=0 to high(yzaehler) do
  yZaehler[i]:=0;
SetLength(Positionenspeicher,0);
SetLength(Positionenspeicher,tiefe);
for i:=0 to high(Positionenspeicher) do
  begin
  SetLength(Positionenspeicher[i],3);
  Positionenspeicher[i,0]:=0;
  Positionenspeicher[i,1]:=0;
  Positionenspeicher[i,2]:=0;
  end;
obererrandfeld.text     := IntToStr(obererrand);
abstandfeld.text        := IntToStr(abstand);
linkerrandfeld.text     := IntToStr(linkerrand);
neuronenradiusfeld.text := IntToStr(neuronradius);

end;

procedure TGraphForm.Kreis(x,y, nr: integer);
begin
  GraphImage.Canvas.Brush.Color:=clWhite;
  GraphImage.Canvas.Ellipse(x-NeuronRadius,y+NeuronRadius,x+NeuronRadius,y-NeuronRadius);
  GraphImage.Canvas.TextOut(x,y,IntToStr(nr));
end;

procedure TGraphForm.FormPaint(Sender: TObject);
begin
//kreis(100,100,0);
end;

procedure TGraphForm.malNeuron(thatNeuron: Neuron);
var x,y:integer;
begin
  if length(yZaehler)+3<thatNeuron.getEbene+2 then setLength(yZaehler, thatNeuron.getEbene+3);
  yZaehler[thatNeuron.getEbene+2]:=yZaehler[thatNeuron.getEbene+2]+1;
  x:=linkerRand+thatNeuron.getEbene*Abstand;
  if ZeichenreihenfolgeGroup.ItemIndex=1 then
    y:=obererRand+Round(yZaehler[thatNeuron.getEbene+2]/2.2)*Abstand* Round(IntPower(-1,yZaehler[thatNeuron.getEbene+2]))+round(Abstand/2*(thatNeuron.getEbene mod 2 +1))
  else if ZeichenreihenfolgeGroup.ItemIndex=0 then
    y:=obererRand+yZaehler[thatNeuron.getEbene+2]*Abstand+ round(Abstand/2*(thatNeuron.getEbene mod 2 +1));
  Kreis(x,y,thatNeuron.getKennung);
  Positionenspeicher[Speicherzaehler,0]:=thatNeuron.getKennung;
  Positionenspeicher[Speicherzaehler,1]:=x ;//linkerRand+thatNeuron.getEbene*Abstand;
  Positionenspeicher[Speicherzaehler,2]:=y ;//yZaehler[thatNeuron.getEbene+2];
  Speicherzaehler:=Speicherzaehler+1;
//  showmessage('Neuron Nr.: '+IntToStr(thatNeuron.getKennung)+' Ebene: '+IntToStr(thatNeuron.getEbene)+' yZaehler: '+IntToStr(yZaehler[thatNeuron.getEbene+2]));
//  yZaehler[thatNeuron.getEbene+2]:=yZaehler[thatNeuron.getEbene+2]+1; Hier stand das frher, jetzt oben
end;

procedure TGraphForm.malKante(von, bis: Neuron);
var i,x1,y1,x2,y2: Integer;
begin
x1:=0;x2:=0;y1:=0;y2:=0;
//An welcher Positionen liegen die Neuronen?
for i:=0 to Speicherzaehler-1 do
  if Positionenspeicher[i,0]=von.getKennung then
    begin
      x1:=Positionenspeicher[i,1];
      y1:=Positionenspeicher[i,2];
    end;
for i:=0 to Speicherzaehler-1 do
  if Positionenspeicher[i,0]=bis.getKennung then
    begin
      x2:=Positionenspeicher[i,1];
      y2:=Positionenspeicher[i,2];
    end;
// Und auf gehts...
  GraphImage.Canvas.MoveTo(x1+NeuronRadius,y1);
  GraphImage.Canvas.LineTo(x2-NeuronRadius,y2);
end;

procedure TGraphForm.malNetz();
var i,j,startindex: Integer;
begin
try
  myNeuronalesNetz.makeNeuronenarray(false);
  GraphForm.init(myNeuronalesNetz.getlengthNeuronenArray);
  GraphForm.visible:=true;
  // Startneuron mitmalen?
  if not szCB.checked then startindex:=1 else startindex:= 0;
  // Nun werden die Neuronen gemalt:
  for i:= startindex to myNeuronalesNetz.getlengthNeuronenArray-1 do
    GraphForm.malNeuron(myNeuronalesNetz.getNeuronFromNeuronenarray(i));
  // Und nun die Kanten:
  for i:=startindex to myNeuronalesNetz.getlengthNeuronenArray-1 do
    for j:=0 to myNeuronalesNetz.getNeuronFromNeuronenarray(i).getLetzterNachfolger() do
      GraphForm.malKante(myNeuronalesNetz.getNeuronFromNeuronenarray(i),myNeuronalesNetz.getNeuronFromNeuronenarray(i).getNachfolger(j));
// Die Reihenfolge des Arrays wird ausgegeben:
GraphImage.Canvas.TextOut(50,60, 'Bearbeitungsreihenfolge der Neuronen:');
for i:=0 to MyNeuronalesNetz.getLengthBerechnungsreihenfolgeArray-1 do
  GraphImage.Canvas.TextOut(50+i*15,80, IntToStr(myNeuronalesNetz.getNeuronFromBerechnungsreihenfolgeArray(i).getKennung));

except
    MessageDlg('Fehler: Es konnte kein Graph erstellt werden!'+chr(13)+'Ist schon ein Neuronales Netz erstellt worden?', mtError, [mbOk], 0);
end;

end;



procedure TGraphForm.takeitClick(Sender: TObject);
begin
obererrand:=strToInt(obererrandfeld.text);
abstand:=strtoint(abstandfeld.text);
linkerrand:=strtoint(linkerrandfeld.text);
neuronradius:=strtoint(neuronenradiusfeld.text);
malNetz();
end;

procedure TGraphForm.Aktualisiere1Click(Sender: TObject);
begin
obererrand:=strToInt(obererrandfeld.text);
abstand:=strtoint(abstandfeld.text);
linkerrand:=strtoint(linkerrandfeld.text);
neuronradius:=strtoint(neuronenradiusfeld.text);
malNetz();
end;

procedure TGraphForm.Speichere1Click(Sender: TObject);
begin
if GraphSavePicDialog.Execute and (GraphSavePicDialog.FileName<>'') then
  GraphImage.Picture.SaveToFile(GraphSavePicDialog.FileName);
end;
end.
