unit NetzverwaltungDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NeuronaleNetze, Neuronen;

type
  TNetzverwaltungForm = class(TForm)
    Neuronenliste1: TListBox;
    Label1: TLabel;
    NeuesNeuronButton: TButton;
    NeuesGewicht: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Neuronenliste2: TListBox;
    NeueEbene: TEdit;
    Label4: TLabel;
    d: TLabel;
    NeueVerbindungButton: TButton;
    Label5: TLabel;
    LoescheNeuronButton: TButton;
    LoescheVerbindungButton: TButton;
    SetzeGewicht: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    procedure FormActivate(Sender: TObject);
    procedure NeuesNeuronButtonClick(Sender: TObject);
    procedure NeueVerbindungButtonClick(Sender: TObject);
    procedure LoescheNeuronButtonClick(Sender: TObject);
    procedure LoescheVerbindungButtonClick(Sender: TObject);
    procedure SetzeGewichtClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  NetzverwaltungForm: TNetzverwaltungForm;

implementation

{$R *.dfm}

procedure TNetzverwaltungForm.FormActivate(Sender: TObject);
var i:Integer;
begin
// Alle Neuronen in die Liste:
Neuronenliste1.Items.Clear;{erstmal leeren}
Neuronenliste2.Items.Clear;
for i:=0 to myNeuronalesNetz.getlengthNeuronenArray-1 do
begin
  Neuronenliste1.Items.AddObject('Neuron Nr. '+InttoStr(myNeuronalesNetz.getNeuronFromNeuronenarray(i).getKennung), myNeuronalesNetz.getNeuronFromNeuronenarray(i));
  Neuronenliste2.Items.AddObject('Neuron Nr. '+InttoStr(myNeuronalesNetz.getNeuronFromNeuronenarray(i).getKennung), myNeuronalesNetz.getNeuronFromNeuronenarray(i));
end;
end;

procedure TNetzverwaltungForm.NeuesNeuronButtonClick(Sender: TObject);
var
  zwN: Neuron;
begin
try
  zwN:=Neuron(Neuronenliste1.Items.Objects[Neuronenliste1.ItemIndex]);
  myNeuronalesNetz.makeNeuron(zwN,StrToInt(NeueEbene.Text),StrToFloat(NeuesGewicht.Text));
except
  MessageDlg('Sie sollten eine gltige Zahl eingeben und ein Neuron whlen!', mtError, [mbOk], 0);
end;

end;

procedure TNetzverwaltungForm.NeueVerbindungButtonClick(Sender: TObject);
var
  zwn1, zwn2: Neuron;
begin
try
  zwN1:=Neuron(Neuronenliste1.Items.Objects[Neuronenliste1.ItemIndex]);
  zwN2:=Neuron(Neuronenliste2.Items.Objects[Neuronenliste2.ItemIndex]);
  myNeuronalesNetz.makeEdge(zwN1, zwN2, StrToFloat(NeuesGewicht.Text));
except
  MessageDlg('Sie sollten Ausgangsneuron, Zielneuron und Gewicht whlen!', mtError, [mbOk], 0);
end;
end;


procedure TNetzverwaltungForm.LoescheNeuronButtonClick(Sender: TObject);
var zwn: Neuron;
begin
try
  zwN:=Neuron(Neuronenliste1.Items.Objects[Neuronenliste1.ItemIndex]);
  myNeuronalesNetz.delNeuron(zwn);
except
  MessageDlg('Es ist ein Fehler aufgetreten!'+chr(13)+'(Es kann aber auch gut sein, da es gar nicht Ihr Fehler war. Das Lschen ist noch nicht ganz ausgereift.)', mtError, [mbOk], 0);
end;

end;

procedure TNetzverwaltungForm.LoescheVerbindungButtonClick(  Sender: TObject);
var zwn1, zwn2: Neuron;
begin
try
  zwN1:=Neuron(Neuronenliste1.Items.Objects[Neuronenliste1.ItemIndex]);
  zwN2:=Neuron(Neuronenliste2.Items.Objects[Neuronenliste2.ItemIndex]);
  myNeuronalesNetz.delEdge(zwn1,zwn2);
except
  MessageDlg('Fehler!'+chr(13)+'(Es kann aber auch gut sein, da es gar nicht Ihr Fehler war. Das Lschen ist noch nicht ganz ausgereift.)', mtError, [mbOk], 0);
end;

end;

procedure TNetzverwaltungForm.SetzeGewichtClick(Sender: TObject);
var zwn1, zwn2: Neuron;
begin
  zwN1:=Neuron(Neuronenliste1.Items.Objects[Neuronenliste1.ItemIndex]);
  zwN2:=Neuron(Neuronenliste2.Items.Objects[Neuronenliste2.ItemIndex]);
  zwn2.setVorgaengerGewicht(StrToFloat(NeuesGewicht.text), zwn1);
end;

end.
