unit NeuronaleNetze;

interface
  uses Neuronen, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Meldungsfenster, Math, DatenquelleGUI, Funktionen;
type
  NeuronalesNetz=class
  private
    StartNeuron: Neuron;
    nextKennung: Integer;
    Neuronenarray: Array of Neuron;
    Berechnungsreihenfolgearray: Array of Neuron;
    NQ: Array of Neuron; // Eine Queue fr Neuronen (NeuronenQueue)
    AM: Array of Array of Integer; // Adjazenzmatrix fr die Ausgabe
    rq: Array of Integer;
    Ergebnis:Real;
  public
    constructor create();
    function makeNeuron(thatVorgaenger: Neuron; thatEbene: Integer; thatGewicht: Real): Neuron;
    procedure delNeuron(thatNeuron: Neuron);
    procedure makeEdge(start, ende: Neuron; Gewicht: Real);
    procedure delEdge(start, ende: Neuron);
    function getNextNumber(): Integer;
    procedure setNextNumber(nr: Integer);
    function getStartNeuron(): Neuron;
    function getNeuronOfKennung(index:integer): Neuron;
    procedure makeNeuronenarray(mitEbeneneinteilung: boolean);
    function getNeuronFromNeuronenarray(i:integer):Neuron;
    procedure legeInNeuronenArray(thatNeuron: Neuron);
    function getNeuronenArray(): String;
    procedure pushNQ(thatNeuron: Neuron);
    function popNQ(): Neuron;
    function getNQ(): String;
    procedure makeAM();
    function AMtoStr(): String;
    function getlengthNeuronenArray():Integer;
    procedure neueKennungen;
    procedure CleanUp;
    procedure setRandomQueue(i:integer);
    function getRandomQueue(): Integer;
    function ErstellePerzeptron(): Integer; // Fehlercodes: -1: Kein Perzeptronstruktur, 1: OK
    procedure Berechne();
    procedure aendereGewicht(thatNeuron, Vorgaenger: Neuron; thatGewicht: Real);
    procedure BerechnungsreihenfolgeWieKennung;
    procedure BerechnungsreihenfolgeWieEbene;
    procedure BerechnungsreihenfolgeWieTim;
    function getLengthBerechnungsreihenfolgearray:Integer;
    function getNeuronFromBerechnungsreihenfolgearray(i:integer):Neuron;
    procedure setNeuronInBerechnungsreihenfolgearray(i:integer; n: Neuron);
    function getErgebnis:Real;
    function getLastNeuron:Neuron;
    procedure berechneAusDaten();
    procedure PerzeptronLernalgorithmus(konstant: boolean; Lernrate: Real; maxEpoche: Integer);
    procedure AdalineLernalgorithmus(konstant: boolean; Lernrate: Real; maxEpoche: Integer; minError: Real);
    procedure Backpropagation(Modus: Integer; Lernrate: Real; Momentumwert: Real; maxEpoche: Integer; minError: Real; deltaAnz: boolean; GewichtsaendAnz: Boolean; praesZufall: Boolean; dbd: Boolean; tkappa: Real; tbeta: Real; txi: Real; tShoweta: boolean; esiZeigen: Boolean; setNrzeigen: Boolean);
    procedure BerechneEtas(kappa, beta, xi: Real; showeta: boolean);
  {public
    function QueryInterface(const IID: TGUID; out Obj: Ohne Typ): HRESULT;
      stdcall; H}
end;

var myNeuronalesNetz: NeuronalesNetz;

implementation

// Ein Netz wird erstellt,
constructor NeuronalesNetz.create();
begin
//showmessage('Erzeugt');
// die eindeutige Kennung zhlt erstmal nur hoch, wird also auf 1 init.
nextKennung:=1;
// StartNeuron:  Schwellwert und Aktivierungsfkt sind egal, AusgabeFunktion immer 1, Ebeno ist -1, Kennung auch -1
// WICHTIG: Eingnge der EingabeNeuronen werden mit den Eingangsgewichten der Nachfolger festgelegt.
StartNeuron:=Neuron.create(0,0,1,-1,-1);
StartNeuron.setAusgang(1);
SetLength(Neuronenarray, 0);
SetLength(Berechnungsreihenfolgearray, 0);
makeNeuronenarray(false);
end;

// Wenn ein Neuron erstellt wird, muss es mit einer Kante sofort verbunden werden. Die Ebene wird vom Benutzer gewhlt werden knnen.
function NeuronalesNetz.makeNeuron(thatVorgaenger: Neuron; thatEbene: Integer; thatGewicht: Real): Neuron;
var NeuesNeuron: Neuron;
begin
NeuesNeuron:=Neuron.create(0,0,0,thatEbene,getNextNumber);
thatVorgaenger.setNachfolger(NeuesNeuron); // Neuron.create(Schwellwert, AktFunkt, AusgFunkt, Ebene);
NeuesNeuron.setVorgaenger(thatVorgaenger,thatGewicht); // Gewicht wird initial auf 1 gesetzt
makeNeuronenarray(false);
result:=NeuesNeuron;
end;

procedure NeuronalesNetz.delNeuron(thatNeuron: Neuron);
var i: integer;
begin
for i:=0 to thatNeuron.getLetzterVorgaenger do
    thatNeuron.getVorgaenger(i).delNachfolger(thatNeuron);
for i:=0 to thatNeuron.getLetzterNachfolger do
    thatNeuron.getNachfolger(i).delVorgaenger(thatNeuron);
cleanUp;// Wer ist noch erreichbar? Die anderen Lschen!

makeNeuronenarray(false);
end;

// Eine Kante zwischen zwei Neuronen, das Gewicht wird im Zielneuron mitgespeichert
procedure NeuronalesNetz.makeEdge(start, ende: Neuron; Gewicht:Real);
begin
if not(start.istNachfolger(ende) AND ende.istVorgaenger(start)) then
  begin
    start.setNachfolger(ende);
    ende.setVorgaenger(start, Gewicht);
    ende.setVorgaengerGewicht(Gewicht,start);
    makeNeuronenarray(false);
  end
  else
    begin
      Showmessage('Es besteht bereits eine Verbindung von '+IntToStr(start.getKennung)+' zu '+IntTostr(ende.getKennung));
      meldungen.app('Es besteht bereits eine Verbindung von '+IntToStr(start.getKennung)+' zu '+IntTostr(ende.getKennung));
    end;
end;

procedure NeuronalesNetz.delEdge(start, ende: Neuron);
begin
start.delNachfolger(ende);
ende.delVorgaenger(start);
cleanUp;
makeNeuronenarray(false);
end;
//

//pushNQ und popNQ sind eine Queue fr Neuronen... mehr nicht.
procedure NeuronalesNetz.pushNQ(thatNeuron:Neuron);
var i: Integer;
begin
setlength(NQ, length(NQ)+1);
for i:=High(NQ)-1 downto 0 do
  NQ[i+1]:=NQ[i];
NQ[0]:=thatNeuron;
//showmessage(inttostr(NQ[0].getKennung)+' wurde in die NQ gelegt.');
end;
function NeuronalesNetz.popNQ(): Neuron;
begin
result:=NQ[High(NQ)];
NQ[High(NQ)]:=nil;
setlength(NQ, length(NQ)-1);
end;

// gibt mir die NQ Queue als String aus.
function NeuronalesNetz.getNQ(): String;
var
  i:integer;
  str: string;
begin
str:='';
for i:=0 to high(NQ) do
  str:= str + inttostr(NQ[i].getkennung) +' ';
  result:=str;
end;

// Ein Neuron, da dieser Methode bergeben wird, wird an nchstmglicher Position in das Neuronenarray (siehe private Attribute) angelegt.
// Dies geschieht mit Hilfe einer BFS (siehe unten)
procedure NeuronalesNetz.legeInNeuronenArray(thatNeuron: Neuron);
begin
SetLength(Neuronenarray, Length(Neuronenarray)+1);
Neuronenarray[High(Neuronenarray)]:=thatNeuron;
//Showmessage('Nummer :'+InttoStr(thatNeuron.getKennung)+' und wurde an Stelle geschrieben: '+InttoStr(High(Neuronenarray))+'.');
end;

// Die BFS. Nach Wahl findet eine Automatische Ebeneneinteilung statt.
procedure NeuronalesNetz.makeNeuronenarray(mitEbeneneinteilung: boolean);
var
  i: Integer;
  zwN: Neuron;
begin
SetLength(Neuronenarray,0);
legeInNeuronenArray(StartNeuron);
pushNQ(StartNeuron);
while (High(NQ)<>-1) do
begin
//showmessage('NQ: '+getnq);
  zwN:=popNQ;
//  showmessage('Aus der Queue herausgenommen wurde Nr.: '+IntToStr(zwN.getkennung));
  for i:=0 to zwN.getLetzterNachfolger do
//    if not(zwN.getNachfolger(i).getBesucht) then !VERSUCHSWEISE WEITER UNTEN DRIN
    begin
      if not(zwN.getNachfolger(i).getBesucht) then   // die if abfrage ist nur testweise drin
        begin
          pushNQ(zwN.getNachfolger(i));
          legeInNeuronenArray(zwN.getNachfolger(i));
        end;
//      if mitEbeneneinteilung then zwN.getNachfolger(i).setEbene(zwN.getEbene+1); OLD
      if mitEbeneneinteilung then zwN.getNachfolger(i).setEbene(max(zwN.letzteEbeneDerVorgaenger, zwN.getEbene) +1);
      zwN.getNachfolger(i).setBesucht(true);
      //zwN.setBesucht(true); brauch ich glaub ich nicht.
    end;
end;

 //  showmessage(getNeuronenArray);
for i:=0 to High(Neuronenarray) do
  Neuronenarray[i].setBesucht(false);
end;

// nur eine ausgabefunktion
function NeuronalesNetz.getNeuronenArray(): String;
var i: Integer; str: String;
begin
for i:=0 to High(Neuronenarray) do
  str:=str+ IntToStr(Neuronenarray[i].getKennung())+' ';
result:=str;
end;

function NeuronalesNetz.getNeuronFromNeuronenarray(i:integer):Neuron;
begin
result:=Neuronenarray[i];
end;

// wird fr die GUI sehr wichtig sein.
function NeuronalesNetz.getNeuronOfKennung(index:integer): Neuron;
var i: integer;
begin
//  makeNeuronenarray(false); ICH ERSTELLE ES JETZT JEDESMAL BEI MAKE UND DEL VON EDGE UND NEURON
  for i:=0 to high(Neuronenarray) do
    if Neuronenarray[i].getKennung=index then begin result:=Neuronenarray[i]; {Showmessage('Gefunden: Neuron Nr.: '+IntToStr(index));} end
end;

// Die Adjazenzmatrix wird erstellt.
procedure NeuronalesNetz.makeAM();
var a,i,j,k: integer;
begin
//makeneuronenarray(true); // Array mit Umsortierung in Ebenen
makeneuronenarray(false); // Array ohne Umsortierung
//Init:
Setlength(AM,length(neuronenarray));
for a:=0 to high(neuronenarray) do
  setlength(AM[a],length(neuronenarray));

//showmessage('Die Matrix hat Groesse: '+inttostr(length(AM))+','+inttostr(length(AM[0])));

// Einstellen der Eintrge
for i:=0 to high(neuronenarray) do
  for k:=0 to neuronenarray[i].getLetzterVorgaenger do
    for j:=0 to high(neuronenarray) do
      if neuronenarray[i].getVorgaenger(k)=neuronenarray[j] then
//      showmessage('Eintrag AM['+inttostr(i)+','+inttostr(j)+']=1');
        AM[j,i]:=1;
AMtoStr();
end;

// Nur eine Ausgabefunktion
function NeuronalesNetz.AMtoStr(): String;
var
  i,j:integer;
  str:string;
begin
  str:='    ';
    // Zeilenbeschriftung
  for i:=0 to High(Neuronenarray) do
  begin
    str:=str+ IntToStr(Neuronenarray[i].getKennung);
    for j:=0 to 3-length(IntToStr(Neuronenarray[i].getKennung))-1 do // Auffllen mit Leerzeichen
      if i<> 0 then str:=str+' ';
    if i=0 then str:=str+'  ';
  end;
  str:=str+chr(13)+chr(10); // Absatz
    // Trennzeile
      str:=str+'----';
  for i:=0 to High(AM) do
  begin
    str:=str+'---';
  end;
  str:=str+chr(13)+chr(10); // Absatz
  for i:=0 to High(AM) do
    begin
    //Spaltenbeschriftung:
    str:=str+ IntToStr(Neuronenarray[i].getKennung);
    for j:=0 to 4-length(IntToStr(Neuronenarray[i].getKennung)) do  // Auffllen mit Leerzeichen
      if i<> 0 then str:=str+' ';
    if i=0 then str:=str+'   ';
    //Matrix selbst
    for j:=0 to High(AM[0]) do
    begin
      str:=str+ IntToStr(AM[i,j]) +'  ';
    end;
    str:=str+chr(13)+chr(10);
    end;
  result:=str;
end;

procedure NeuronalesNetz.setRandomQueue(i:integer);
var k: integer;
begin
setlength(rq,i);
for k:=0 to i-1 do
  begin
    rq[k]:=k;
  end;
end;

function NeuronalesNetz.getRandomQueue(): Integer;
var
  k: integer;
  w: integer;
  str:string;
begin
  Randomize;
  w:=RandomRange(0,high(rq)+1);
  result:=rq[w];

  for k:=w to high(rq)-1 do
    rq[k]:=rq[k+1];
  Setlength(rq, high(rq));

  str:='';
  for k:=0 to high(rq) do
    str:=str+' '+inttoStr(rq[k]);
//  Meldungen.app(':'+str);
end;

function NeuronalesNetz.ErstellePerzeptron; // Fehlercodes: -1: Kein Perzeptronstruktur, 1: OK
var i,maxLayer: Integer;
begin
try
// Hat das Netz eine erlaubte Struktur?
maxLayer:=-2;
for i:=0 to high(Neuronenarray) do
  if maxLayer < Neuronenarray[i].getEbene() then maxLayer:=Neuronenarray[i].getEbene();
if (maxLayer<>1) then
  begin
    MessageDlg('Ein Perzeptron darf keine Neuronen hinter Schicht 1 haben.' +chr(13)+ 'Verndern Sie die Struktur.', mtError, [mbOk], 0);
    Meldungen.app('Ein Perzeptron darf keine Neuronen hinter Schicht 1 haben.' +chr(13)+ 'Verndern Sie die Struktur.');
    result:=-1;
  end
else
  begin
    // alle Neuronen bekommen die Aktivierungsfunktion sgn und die Ausgangsfunktion id.
    for i:=0 to high(Neuronenarray) do
    begin
      if Neuronenarray[i].getEbene=1 then // die eigentlichen perzeptronen
        begin
          Neuronenarray[i].setAktFkt(2);
          Neuronenarray[i].setAusgFkt(0);
        end;
      if Neuronenarray[i].getEbene=0 then // die eingabeneuronen haben identittsfkten und schwellwert=0
        begin
          Neuronenarray[i].setAktFkt(0);
          Neuronenarray[i].setAusgFkt(0);
          Neuronenarray[i].setSchwellwert(0);
        end;
    end;
    result:=1;
  end;
except
     MessageDlg('Sie sollten schon ein Neuronales Netz erstellt haben!', mtError, [mbOk], 0);
     result:=-2;
end;
end;

procedure NeuronalesNetz.Berechne(); // In der Reihenfolge des Neuronenarrays
var i: Integer; zw: Real;
begin
for i:=1 to High(BerechnungsreihenfolgeArray) do // das Startneuron wird nicht berechnet!
  begin
  zw:=BerechnungsreihenfolgeArray[i].berechne;
  if BerechnungsreihenfolgeArray[i].getLetzterNachfolger=-1 then Ergebnis:=zw;
  end;
end;

procedure NeuronalesNetz.aendereGewicht(thatNeuron, Vorgaenger: Neuron; thatGewicht: Real);
begin
  thatNeuron.setVorgaengerGewicht(thatGewicht, Vorgaenger);
end;

function NeuronalesNetz.getNextNumber(): Integer;
begin
result:=nextKennung;
nextKennung:=nextKennung+1;
end;

procedure NeuronalesNetz.setNextNumber(nr: Integer);
begin
showmessage('Nicht Implementiert');
end;

function NeuronalesNetz.getStartNeuron(): Neuron;
begin
result:=StartNeuron;
end;

function NeuronalesNetz.getlengthNeuronenArray():Integer;
begin
result:=length(Neuronenarray);
end;

procedure NeuronalesNetz.neueKennungen();
var i:integer;
begin
for i:=1 to high(neuronenarray) do
  neuronenarray[i].setKennung(i-1);
end;

procedure NeuronalesNetz.CleanUp; //WICHTIG: AUFRUF BEI EXISTENZ DES ALTEN NEURONENARRAYS
var
  i: Integer;
  zwN: Neuron;
begin
setlength(nq,0);
// Alle sind erstmal nicht erreichbar
for i:=0 to high(neuronenarray) do
  Neuronenarray[i].setErreichbar(false);
// Dann die erreichbaren auf Erreichbar setzen:
pushNQ(StartNeuron);
StartNeuron.setErreichbar(true);
while (High(NQ)<>-1) do
begin
  zwN:=popNQ;
  for i:=0 to zwN.getLetzterNachfolger do
    if not(zwN.getNachfolger(i).getErreichbar) then
    begin
      pushNQ(zwN.getNachfolger(i));
      zwN.getNachfolger(i).setErreichbar(true);
      zwN.setErreichbar(true);
    end;
end;
// Dann die anderen zerstren
for i:=0 to high(neuronenarray) do
  If Neuronenarray[i].getErreichbar=false then begin Meldungen.app('DESTR '+inttostr(Neuronenarray[i].getKennung)); Neuronenarray[i].Destroy; end;
end;

procedure NeuronalesNetz.BerechnungsreihenfolgeWieKennung;
var i,k: Integer; v: Neuron;
begin
SetLength(BerechnungsreihenfolgeArray, Length(Neuronenarray));
for i:=0 to High(Neuronenarray) do
  BerechnungsreihenfolgeArray[i]:=Neuronenarray[i];
// Und nun nach Kennung sortieren...
for k:=1 to high(BerechnungsreihenfolgeArray) do
  begin
  i:=k;
  v:=Berechnungsreihenfolgearray[i];
    while (i>0) and (Berechnungsreihenfolgearray[i-1].getKennung > v.getKennung) do
    begin
      Berechnungsreihenfolgearray[i]:=Berechnungsreihenfolgearray[i-1];
      dec(i);
    end;
    Berechnungsreihenfolgearray[i]:=v;
  end;
end;

procedure NeuronalesNetz.BerechnungsreihenfolgeWieEbene;
var i,k: Integer; v: Neuron;
begin
SetLength(BerechnungsreihenfolgeArray, Length(Neuronenarray));
for i:=0 to High(Neuronenarray) do
  BerechnungsreihenfolgeArray[i]:=Neuronenarray[i];
// Und nun nach Ebene sortieren...
for k:=1 to high(BerechnungsreihenfolgeArray) do
  begin
  i:=k;
  v:=Berechnungsreihenfolgearray[i];
    while (i>0) and (Berechnungsreihenfolgearray[i-1].getEbene > v.getEbene) do
    begin
      Berechnungsreihenfolgearray[i]:=Berechnungsreihenfolgearray[i-1];
      dec(i);
    end;
    Berechnungsreihenfolgearray[i]:=v;
  end;
end;



procedure NeuronalesNetz.BerechnungsreihenfolgeWieTim;
var i: Integer;
begin
SetLength(BerechnungsreihenfolgeArray, Length(Neuronenarray));
for i:=0 to High(Neuronenarray) do
  BerechnungsreihenfolgeArray[i]:=Neuronenarray[i];
end;

function NeuronalesNetz.getLengthBerechnungsreihenfolgearray():Integer;
begin
result:=length(Berechnungsreihenfolgearray);
end;

function NeuronalesNetz.getNeuronFromBerechnungsreihenfolgearray(i:integer):Neuron;
begin
result:=Berechnungsreihenfolgearray[i];
end;

procedure NeuronalesNetz.setNeuronInBerechnungsreihenfolgearray(i:integer; n: Neuron);
begin
Berechnungsreihenfolgearray[i]:=n;
end;

function NeuronalesNetz.getErgebnis;
begin
result:=ergebnis;
end;

function NeuronalesNetz.getLastNeuron:Neuron;
begin
result:=Berechnungsreihenfolgearray[High(Berechnungsreihenfolgearray)];
end;

procedure NeuronalesNetz.berechneAusDaten();
var i,z: integer;
begin
for z:=0 to DatenquelleForm.countsets-2 do
begin
// nur eine Zeile:
for i:=0 to DatenquelleForm.countIn-1 do
  myNeuronalesNetz.getStartNeuron.getNachfolger(i).setVorgaengerGewicht(DatenquelleForm.daten[z,i],myNeuronalesNetz.getStartNeuron);
myNeuronalesNetz.Berechne();
Meldungen.app('Das Ergebnis des Neurons ohne Nachfolger lautet: '+FloatToStr(myNeuronalesNetz.getErgebnis));
end;
end;

procedure NeuronalesNetz.PerzeptronLernalgorithmus(konstant: boolean; Lernrate: Real; maxEpoche: Integer);
var
i,z: integer; Eingaben, Gewichte: String;
istwert, sollwert: real; aenderung: boolean; aend: string;
epochefehlerfrei: boolean; epochenzahl: integer;
w_old, diff, x_akt, w_neu: real;
begin
epochenzahl:=1;
epochefehlerfrei:=false;
while (not epochefehlerfrei AND (epochenzahl<=maxEpoche)) do
begin
epochefehlerfrei:=true;
meldungen.app('Nun folgt Epoche '+inttostr(epochenzahl));
if not konstant then lernrate:=(1/epochenzahl);
  for z:=0 to DatenquelleForm.countsets-2 do
    begin
      Eingaben:='';
      Gewichte:='';
      // nur eine Zeile:
      for i:=0 to DatenquelleForm.countIn-1 do
        begin
        myNeuronalesNetz.getStartNeuron.getNachfolger(i).setVorgaengerGewicht(DatenquelleForm.daten[z,i],myNeuronalesNetz.getStartNeuron);// Eingnge setzen!
        Eingaben:=Eingaben+FloatToStr(DatenquelleForm.daten[z,i])+' ';
        Gewichte:=Gewichte+FloatToStr(myNeuronalesNetz.getLastNeuron.getVorgaengerGewicht(i))+' ';
        end;
    myNeuronalesNetz.Berechne();
    istwert:=myNeuronalesNetz.getErgebnis;
    sollwert:=DatenquelleForm.daten[z,DatenquelleForm.countIn];//bei countIn liegt der erste Ausgang
    if istwert<>sollwert then begin aenderung:=true; epochefehlerfrei:=false; end else aenderung:=false;
    if aenderung then aend:='Ja' else aend:='Nein';
Meldungen.app('i:'+IntToStr(z)+' Eing:'+Eingaben+' Gew:'+Gewichte+' Soll:'+FloatToStr(sollwert)+' Ist:'+FloatToStr(istwert)+' Lernr: '+floattostr(lernrate)+' Aend:'+aend) ;
    // nderung der Gewichte wenn aenderung:
    if aenderung then
    begin
      for i:=0 to DatenquelleForm.countIn-1 do
        begin
        w_old:=myNeuronalesNetz.getLastNeuron.getVorgaengerGewicht(i);
//        lernrate
//        sollwert
//        istwert
        diff:=sollwert-istwert;
        x_akt:=DatenquelleForm.daten[z,i];
        w_neu:=w_old+lernrate*diff*x_akt;
        myNeuronalesNetz.getLastNeuron.setVorgaengerGewicht(myNeuronalesNetz.getLastNeuron.getVorgaengerGewicht(i)+(lernrate*(sollwert-istwert)*DatenquelleForm.daten[z,i]), myNeuronalesNetz.getLastNeuron.getVorgaenger(i));
        meldungen.app(floattostr(w_neu)+':='+FloatToStr(w_old)+'+'+FloatToStr(lernrate)+'*('+FloatToStr(sollwert)+'-'+FloatToStr(istwert)+')*'+FloatToStr(x_akt));
        end;
    // nderung des Schwellwertes:
    Meldungen.app('Schwellwert:'+floatToStr(myNeuronalesNetz.getLastNeuron.getSchwellwert)+' => '+floattostr(myNeuronalesNetz.getLastNeuron.getSchwellwert+lernrate*(sollwert-istwert)*(-1)));
    myNeuronalesNetz.getLastNeuron.setSchwellwert(myNeuronalesNetz.getLastNeuron.getSchwellwert+lernrate*(sollwert-istwert)*(-1));
    end;
    end;
  inc(epochenzahl);
end;
end;

procedure NeuronalesNetz.AdalineLernalgorithmus(konstant: boolean; Lernrate: Real; maxEpoche: Integer; minError: Real);
var
i,z: integer; Eingaben, Gewichte: String;
istwert, sollwert: real;
epochenzahl: integer;
w_old, diff, x_akt, w_neu: real;
Aktfkt_old: Integer;
quadr_summe, quadr_fehler, oldquadr_fehler, fehlerdiff: Real;
begin
// Im Gegensatz zum Perzeptron mu ich erstmal die Aktivierungsfunktion von sgn auf id ndern,
// um flexibel zu sein, merke ich mir erstmal die ehemalige Funktion
Aktfkt_old:=myNeuronalesNetz.getLastNeuron.getAktFkt;
// Nun neu setzen:
myNeuronalesNetz.getLastNeuron.setAktFkt(0); // auf ID
epochenzahl:=1;
// der fehler ist am anfang seeeehr gro:
quadr_fehler:=9999999999999;
fehlerdiff:=9999999999999;
while (fehlerdiff>=minError) AND (epochenzahl<=maxEpoche) do
begin
//showmessage('fehlerdiff-minError: '+floattostr(fehlerdiff-minerror));
quadr_summe:=0;
oldquadr_fehler:=quadr_fehler;
meldungen.app('Nun folgt Epoche '+inttostr(epochenzahl));
if not konstant then lernrate:=(1/epochenzahl);
  for z:=0 to DatenquelleForm.countsets-2 do
    begin
      Eingaben:='';
      Gewichte:='';
      // nur eine Zeile:
      for i:=0 to DatenquelleForm.countIn-1 do
        begin
        myNeuronalesNetz.getStartNeuron.getNachfolger(i).setVorgaengerGewicht(DatenquelleForm.daten[z,i],myNeuronalesNetz.getStartNeuron);// Eingnge setzen!
        Eingaben:=Eingaben+FloatToStr(DatenquelleForm.daten[z,i])+' ';
        Gewichte:=Gewichte+FloatToStr(myNeuronalesNetz.getLastNeuron.getVorgaengerGewicht(i))+' ';
        end;

      myNeuronalesNetz.Berechne();
      istwert:=myNeuronalesNetz.getErgebnis;
      sollwert:=DatenquelleForm.daten[z,DatenquelleForm.countIn];//bei countIn liegt der erste Ausgang
      diff:=sollwert-istwert;
      // Die Ausgabe hnlich der Tabelle wie in der Vorlesung
      Meldungen.app('i:'+IntToStr(z)+' Eing:'+Eingaben+' Gew:'+Gewichte+' Soll:'+FloatToStr(sollwert)+' Ist:'+FloatToStr(istwert)+' Lernr: '+floattostr(lernrate)+' Fehler:'+floattoStr(diff)) ;

      // nderung der Gewichte findet nun immer statt:
        for i:=0 to DatenquelleForm.countIn-1 do
          begin
          w_old:=myNeuronalesNetz.getLastNeuron.getVorgaengerGewicht(i);
//         lernrate
//         sollwert
//         istwert
//          diff:=sollwert-istwert;
          x_akt:=DatenquelleForm.daten[z,i];
          w_neu:=w_old+lernrate*diff*x_akt;
          //Der Entscheidende Schritt: Das Gewicht wird neu gesetzt:
          myNeuronalesNetz.getLastNeuron.setVorgaengerGewicht(w_neu, myNeuronalesNetz.getLastNeuron.getVorgaenger(i));
          //meldungen.app(floattostr(w_neu)+':='+FloatToStr(w_old)+'+'+FloatToStr(lernrate)+'*('+FloatToStr(sollwert)+'-'+FloatToStr(istwert)+')*'+FloatToStr(x_akt));
          end;
      // nderung des Schwellwertes:
      Meldungen.app('Schwellwert:'+floatToStr(myNeuronalesNetz.getLastNeuron.getSchwellwert)+' => '+floattostr(myNeuronalesNetz.getLastNeuron.getSchwellwert+lernrate*(sollwert-istwert)*(-1)));
      myNeuronalesNetz.getLastNeuron.setSchwellwert(myNeuronalesNetz.getLastNeuron.getSchwellwert+lernrate*(sollwert-istwert)*(-1));
      // Berechnung des Fehlers:
      quadr_summe:=quadr_summe+sqr(diff);
    end;
  // Berechnung des Fehlers:
  quadr_fehler:=quadr_summe/(DatenquelleForm.countsets-1);
  fehlerdiff:=abs(oldquadr_fehler-quadr_fehler);
  Meldungen.app('Quadratischer Fehler: '+floattostr(quadr_fehler)+':='+floattostr(quadr_summe)+'/'+inttostr(DatenquelleForm.countsets-1)+chr(13)+chr(10)+'Betrag der Differenz zum alten quadr. Fehler: '+floattostr(fehlerdiff)+':='+floattostr(oldquadr_fehler)+'-'+floattostr(quadr_fehler));
  Meldungen.app('------------------------------------------------------------------------------------------------');
  inc(epochenzahl);
end;
// Und die Funktion wieder zurcksetzen:
showmessage('Fertig!');
myNeuronalesNetz.getLastNeuron.setAktFkt(Aktfkt_old);
end;

procedure NeuronalesNetz.Backpropagation(Modus: Integer; Lernrate: Real; Momentumwert: Real; maxEpoche: Integer; minError: Real; deltaAnz: boolean; GewichtsaendAnz: Boolean; praesZufall: Boolean; dbd: Boolean; tkappa: Real; tbeta: Real; txi: Real; tShoweta: boolean; esiZeigen: Boolean; setNrzeigen: Boolean);
var
  h,i,j,k,l,m,n,o,p,q,w: Integer;
  Eingaben: String;
  Fehlervektor: Array of Real;
  psse,tsse: Real;
  Ausgabeneuronen: Array of Neuron;
  zwSumme: Real;
  w_alt_alt, w_alt, w_neu,delta_akt,y_akt, ist, soll, w_akt, gesamtfehler,momentum_akt, AktfAbl: Real;
  vorgaengerposition: integer;

begin
// Initialisiere Fehlervektor und Ausgabeneuronenarray
setlength(Fehlervektor, DatenquelleForm.countOut);
setlength(Ausgabeneuronen, DatenquelleForm.countOut);
if dbd then
  for w:=0 to high(Berechnungsreihenfolgearray) do
    Berechnungsreihenfolgearray[w].initdbd(Lernrate);
for h:=0 to DatenquelleForm.countOut-1 do
  Ausgabeneuronen[h]:=Berechnungsreihenfolgearray[high(Berechnungsreihenfolgearray)-DatenquelleForm.CountOut+1+h];
// Los gehts!
// Schleife ber Epochen
for i:=0 to maxEpoche do
  begin
  // Batch oder Online?
  if Modus=1 then
  for w:=0 to high(Berechnungsreihenfolgearray) do
    Berechnungsreihenfolgearray[w].initBatchVorgaengerGewicht;

  Meldungen.app('Epoche '+IntToStr(i));
  // Schleife ber Trainingsbeispielen
  tsse:=0;
  setRandomQueue(DatenquelleForm.countsets-1);
//  Showmessage(IntToStr(DatenquelleForm.countsets-1));
  for q:=1 to DatenquelleForm.countsets-1 do
    begin
    if praeszufall then j:=getRandomQueue else j:=q-1;
    if setNrzeigen then Meldungen.app('Set '+IntToStr(j));
    // setze Beispiele in den Eingang
    Eingaben:='';
    for k:=0 to DatenquelleForm.countIn-1 do
      begin
      myNeuronalesNetz.getStartNeuron.getNachfolger(k).setVorgaengerGewicht(DatenquelleForm.daten[j,k],myNeuronalesNetz.getStartNeuron);// Eingnge setzen!
      Eingaben:=Eingaben+FloatToStr(DatenquelleForm.daten[j,k])+' ';
      end;
      If esiZeigen then Meldungen.app('Eingaben '+Eingaben);
      // Berechne
      myNeuronalesNetz.Berechne();
      // Berechne delta auf jedem Ausgangsneuronen (Schicht n)...
      psse:=0;
      for l:=0 to High(Ausgabeneuronen) do
        begin
        soll  := DatenquelleForm.Daten[j,DatenquelleForm.countIn+l];
        ist   := Ausgabeneuronen[l].getAusgang();
        Fehlervektor[l] :=  soll - ist;
        delta_akt :=     Funktion.aufruf(Ausgabeneuronen[l].getSumme, Ausgabeneuronen[l].getAktFkt+100) * Fehlervektor[l];
        if esiZeigen then Meldungen.app('AusgabeNeuron Nr.: '+InttoStr(Ausgabeneuronen[l].getKennung)+' Soll: '+FloattoStr(soll)+' Ist: '+floattostr(ist));
        if deltaanz then Meldungen.app('AusgabeNeuron Nr.: '+InttoStr(Ausgabeneuronen[l].getKennung)+' Delta: '+FloatTostr(delta_akt)+' :=  '+FloatToStr(Funktion.aufruf(Ausgabeneuronen[l].getSumme, Ausgabeneuronen[l].getAktFkt+100))+' * '+FloatToStr(Fehlervektor[l]));
        //...und speichere diesen
        Ausgabeneuronen[l].setdelta(delta_akt);
        psse:=psse+sqr(Fehlervektor[l]);
        end;
        psse:=psse / DatenquelleForm.CountOut;
      // Berechne fr alle Vorgngerneuronen das delta... (nur NICHT startneuron!)
      for m:=High(Berechnungsreihenfolgearray)-DatenquelleForm.CountOut downto 1 do   // 1 temporr durch anzahl eingabeneuronen ersetzt
        begin
            // Aufsummieren: Fehler des Nachfolgers * Gewicht zum Nachfolger * wie vorher
            zwSumme:=0;
            for n:=0 to Berechnungsreihenfolgearray[m].getLetzterNachfolger do
              begin
                delta_akt:=(Berechnungsreihenfolgearray[m].getNachfolger(n).getDelta);
                w_akt:= Berechnungsreihenfolgearray[m].getNachfolger(n).getVorgaengerGewicht(Berechnungsreihenfolgearray[m]);
                zwSumme:= zwSumme + (delta_akt * w_akt);
              end;
            AktfAbl:= Funktion.Aufruf(Berechnungsreihenfolgearray[m].getSumme,Berechnungsreihenfolgearray[m].getAktFkt+100);
            delta_akt :=  AktfAbl* zwSumme;
            Berechnungsreihenfolgearray[m].setDelta(delta_akt);
            if deltaAnz then Meldungen.app('VerstecktesNeuron Nr. '+IntToStr(Berechnungsreihenfolgearray[m].getKennung)+' Delta: '+FloatToStr(Berechnungsreihenfolgearray[m].getDelta)+' := '+FloatToStr(AktfAbl)+' * '+FloatToStr(zwSumme));
            if deltaAnz then Meldungen.app('Interner Zustand: '+FloatToStr(Berechnungsreihenfolgearray[m].getSumme));
              // ...und passe die Gewichte im Nachfolgeneuron an
                  //hier stand mal die schleife von unten (in =)
        end;
        // Gewichtsanpassungen
      for m:=High(Berechnungsreihenfolgearray)-DatenquelleForm.CountOut downto 1 do
        begin
        //=================== Die Gewichte werden nach der Berechnung ALLER deltas erst angepasst: nicht sicher, ob richtig.
                for o:=0 to Berechnungsreihenfolgearray[m].getLetzterNachfolger do
                    begin
                      //vorgaengerposition:=Berechnungsreihenfolgearray[m].getNachfolger(o).getIndexOfVorgaenger(Berechnungsreihenfolgearray[m]);
                      w_alt:=Berechnungsreihenfolgearray[m].getNachfolger(o).getVorgaengerGewicht(Berechnungsreihenfolgearray[m]); // Berechnungsreihenfolgearray[m] statt vorgaengerposition
                      delta_akt:=Berechnungsreihenfolgearray[m].getNachfolger(o).getDelta;
                      //delta_akt:=Berechnungsreihenfolgearray[m].getDelta;
                      y_akt:=Berechnungsreihenfolgearray[m].getAusgang;
                      w_alt_alt:= Berechnungsreihenfolgearray[m].getNachfolger(o).getaltesVorgaengerGewicht(Berechnungsreihenfolgearray[m]); // Berechnungsreihenfolgearray[m] statt vorgaengerposition
                      momentum_akt:= (w_alt - w_alt_alt );
                      if dbd then Lernrate:=Berechnungsreihenfolgearray[m].getNachfolger(o).getEta(Berechnungsreihenfolgearray[m]);
                      w_neu:= w_alt + (Lernrate * delta_akt * y_akt) + Momentumwert * momentum_akt;
                      Berechnungsreihenfolgearray[m].getNachfolger(o).setAltesVorgaengerGewicht(w_alt,BerechnungsreihenfolgeArray[m]);
                      if Modus=0 then Berechnungsreihenfolgearray[m].getNachfolger(o).setVorgaengerGewicht(w_neu, BerechnungsreihenfolgeArray[m]);
                      if Modus=1 then Berechnungsreihenfolgearray[m].getNachfolger(o).setBatchVorgaengerGewicht(w_neu, BerechnungsreihenfolgeArray[m]);
                      if GewichtsaendAnz then Meldungen.app('Neuron '+IntToStr(Berechnungsreihenfolgearray[m].getKennung)+' zu '+IntToStr(Berechnungsreihenfolgearray[m].getNachfolger(o).getKennung)+'  '+FloatToStr(w_neu)+' := '+FloatToStr(w_alt)+' + '+FloatToStr(Lernrate)+' * '+FloatToStr(delta_akt)+' * '+FloatToStr(y_akt)+' + '+FloatToStr(Momentumwert)+' * ('+FloatToSTr(w_alt)+' - '+FloatToStr(w_alt_alt)+')');
                    end;
        //===================
          w_alt:=Berechnungsreihenfolgearray[m].getSchwellwert;
          delta_akt:=Berechnungsreihenfolgearray[m].getDelta;
          y_akt:= -1;
          w_alt_alt:= Berechnungsreihenfolgearray[m].getAlterSchwellwert;
          momentum_akt:= (w_alt - w_alt_alt );
          if dbd then Lernrate:=Berechnungsreihenfolgearray[m].getetaSchwellwert;
          w_neu:= w_alt + (Lernrate * delta_akt * y_akt);// + Momentumwert * momentum_akt;
          Berechnungsreihenfolgearray[m].setAlterSchwellwert(w_alt);
          if Modus=0 then Berechnungsreihenfolgearray[m].setSchwellwert(w_neu);
          if Modus=1 then Berechnungsreihenfolgearray[m].setBatchSchwellwert(w_neu);
          if GewichtsaendAnz then Meldungen.app('Schwellwert Neuron '+IntToStr(Berechnungsreihenfolgearray[m].getKennung)+'  '+FloatToStr(w_neu)+' := '+FloatToStr(w_alt)+' + '+FloatToStr(Lernrate)+' * '+FloatToStr(delta_akt)+' * '+FloatToStr(y_akt)+' + '+FloatToStr(Momentumwert)+' * ('+FloatToSTr(w_alt)+' - '+FloatToStr(w_alt_alt)+')');
        end;
     // Lernraten nach delta-bar-delta Regel anpassen:
    if dbd then BerechneEtas(tkappa,tbeta,txi, tshoweta);

    tsse:=tsse+psse;

    end; // Countsets
    // Batchzuweisung von Gewichten und Schwellwert:
    if Modus=1 then
    for o:=DatenquelleForm.countin+1 to High(Berechnungsreihenfolgearray) do
      begin
      Berechnungsreihenfolgearray[o].batchWerteUebernehmen(DatenquelleForm.countsets-1);
      end;
    Meldungen.app('TSSE: '+FloatToStr(tsse));
    if tsse<=minError then Exit;
end; // Epochen
end; // procedure


procedure NeuronalesNetz.BerechneEtas(kappa, beta, xi: Real; showeta: boolean);
var
  i,v: Integer;
  aktN: Neuron;
  zw: Real;
begin
  for i:=high(Berechnungsreihenfolgearray) downto DatenquelleForm.countIn+1 do
    begin
    // fr jedes Neuron: i
      aktN:=Berechnungsreihenfolgearray[i];
      // fuer alle Vorgaenger
        for v:=0 to aktN.getLetzterVorgaenger do
        begin
        // Berechne D
          aktN.setD(aktN.getDelta * aktN.getVorgaenger(v).getAusgang , aktN.getVorgaenger(v));
        // Berechne delta_eta
          zw:=(aktN.getD(aktN.getVorgaenger(v)) * aktN.getS(aktN.getVorgaenger(v)));
          if      zw>0 then aktN.setDelta_Eta(kappa,aktN.getVorgaenger(v))
          else if zw<0 then aktN.setDelta_Eta(-1 * beta * aktN.getEta(aktN.getVorgaenger(v)),aktN.getVorgaenger(v))
          else              aktN.setDelta_Eta(0,aktN.getVorgaenger(v));
        // Berechne S
          aktN.setS( (1-xi) * aktN.getD(aktN.getVorgaenger(v)) + xi*aktN.getS(aktN.getVorgaenger(v))  ,aktN.getVorgaenger(v));
        // Berechne Eta
          aktN.setEta( aktN.getEta(aktN.getVorgaenger(v))+aktN.getDelta_Eta(aktN.getVorgaenger(v)) ,aktN.getVorgaenger(v));
          if showeta then meldungen.app('ETA von '+inttostr(aktN.getVorgaenger(v).getKennung)+' zu '+inttostr(aktn.getKennung)+' ist jetzt '+floattostr(aktN.getEta(aktn.getVorgaenger(v))));
        end;
      // nun noch fr den Schwellwert:
        // Berechne D
          aktN.setDSchwellwert(aktN.getDelta * (-1));
        // Berechne delta_eta
          zw:=(aktN.getDSchwellwert * aktN.getSSchwellwert);
          if      zw>0 then aktN.setDelta_EtaSchwellwert(kappa)
          else if zw<0 then aktN.setDelta_EtaSchwellwert(-1 * beta * aktN.getEtaSchwellwert)
          else              aktN.setDelta_EtaSchwellwert(0);
        // Berechne S
          aktN.setSSchwellwert( (1-xi) * aktN.getDSchwellwert + xi*aktN.getSSchwellwert);
        // Berechne Eta
          aktN.setEtaSchwellwert( aktN.getEtaSchwellwert+aktN.getDelta_EtaSchwellwert);
          if showeta then meldungen.app('ETA Schwellwert von Neuron '+ IntToStr(aktN.getKennung) +' ist jetzt '+floattostr(aktN.getEtaSchwellwert));
    end;
end;

end.


