unit Neuronen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Funktionen, Meldungsfenster;

type
  Neuron=class
  private
    delta: Real;
    summe: Real;
    Kennung: Integer;
    Ebene: Integer;
    Schwellwert: real;
    alterSchwellwert: real;
    AktFkt: Integer;
    AusgFkt: Integer;
    Vorgaenger: Array of Neuron;
    Nachfolger: Array of Neuron;
    VorgaengerGewicht: Array of Real;
    altesVorgaengerGewicht: Array of Real;
    batchVorgaengerGewicht: Array of Real;
    batchSchwellwert: Real;
    ausgang: real;
    besucht: Boolean;
    erreichbar: boolean;
    // fr delta-bar-delta Regel
    D: Array of Real;
    S: Array of Real;
    eta: Array of Real;
    delta_eta: Array of Real;
    DSchwellwert: Real;
    SSchwellwert: Real;
    etaSchwellwert: Real;
    delta_etaSchwellwert: Real;
  public
    constructor create(thatSchwellwert: Real; thatAktFkt: Integer; thatAusgFkt: Integer; thatEbene: Integer; thatKennung: Integer);
    procedure setVorgaenger(thatNeuron: Neuron; thatGewicht: Real);
    procedure delVorgaenger(thatNeuron: Neuron);
    procedure setNachfolger(thatNeuron: Neuron);
    procedure delNachfolger(thatNeuron: Neuron);
    procedure setVorgaengerGewicht(thatGewicht: Real; VorgaengerNeuron: Neuron);
    procedure setAltesVorgaengerGewicht(thatGewicht: Real; VorgaengerNeuron: Neuron);
    procedure setAlteVorgaengerGewichte();
    function getVorgaengerGewicht(i: Integer): Real; overload;
    function getAltesVorgaengerGewicht(i : Integer): Real; overload;
    function getVorgaengerGewicht(thatNeuron: Neuron): Real; overload;
    function getAltesVorgaengerGewicht(thatNeuron: Neuron): Real; overload;
    procedure setBatchVorgaengerGewicht(thatGewicht: Real; VorgaengerNeuron: Neuron);
    function getBatchVorgaengerGewicht(thatNeuron: Neuron): Real;
    procedure setEta(e: Real; VorgaengerNeuron: Neuron);
    function getEta(VorgaengerNeuron:Neuron): Real;
    procedure setBatchSchwellwert(wert: Real);
    function getBatchSchwellwert(): Real;
    procedure batchWerteUebernehmen(x:integer);
    procedure initBatchVorgaengerGewicht();
    function getIndexOfVorgaenger(thatNeuron: Neuron): Integer;
    function getEbene(): Integer;
    procedure setEbene(i: Integer);
    procedure setKennung(thatKennung: Integer);
    function getKennung(): Integer;
    function getVorgaenger(i: Integer): Neuron;
    function getNachfolger(i: Integer): Neuron;
    function getLetzterVorgaenger(): Integer;
    function getLetzterNachfolger(): Integer;
    function getBesucht(): Boolean;
    procedure setBesucht(b: boolean);
    function maximum(i,j:integer):integer;
    function getAusgang(): real;
    procedure setAusgang(a:real);
    function getErreichbar: Boolean;
    procedure setErreichbar(b: Boolean);
    function berechne:Real;
    procedure setAktFkt(i:integer);
    procedure setAusgFkt(i:integer);
    function getAktFkt():integer;
    function getAusgFkt():integer;
    function getSchwellwert(): Real;
    procedure setSchwellwert(r:real);
    function istVorgaenger(thatNeuron:Neuron):boolean;
    function istNachfolger(thatNeuron:Neuron):boolean;
    function letzteEbeneDerVorgaenger(): integer;
    function getDelta: Real;
    procedure setDelta(r: real);
    function getSumme: Real;
    function getAlterSchwellwert: Real;
    procedure setAlterSchwellwert(s: real);
    procedure setD(w:real; vorgaengerNeuron: Neuron);
    function getD(vorgaengerNeuron: Neuron): real;
    procedure setS(w:real;vorgaengerNeuron: Neuron);
    function getS(vorgaengerNeuron: Neuron):real;
    function getDelta_Eta(vorgaengerNeuron: Neuron):real;
    procedure setDelta_Eta(w:real;vorgaengerNeuron: Neuron);
    function getDSchwellwert: real;
    procedure setDSchwellwert(w:real);
    procedure setSSchwellwert(w:real);
    function getSSchwellwert:real;
    procedure setetaSchwellwert(w:real);
    function getetaSchwellwert:real;
    procedure setdelta_etaSchwellwert(w:real);
    function getdelta_etaSchwellwert:real;
    procedure initdbd(starteta:real);
end;

implementation

// Ein Neues Neuron wird erzeugt: bergabe: Schwellwert, Aktivierungsfunktion, Ausgabefunktion, Ebene, Kennung (eindeutig)
// Initialisierung
constructor Neuron.create(thatSchwellwert: Real; thatAktFkt: Integer; thatAusgFkt: Integer; thatEbene: Integer; thatKennung: Integer);
begin
  Schwellwert:=thatSchwellwert;
  alterSchwellwert:=thatSchwellwert;
  AktFkt:=thatAktFkt;
  AusgFkt:=thatAusgFkt;
  SetLength(Vorgaenger, 0);
  SetLength(Nachfolger, 0);
  SetLength(VorgaengerGewicht, 0);
  SetLength(altesVorgaengerGewicht, 0);
  SetLength(batchVorgaengerGewicht, 0);
//  letzterVorgaenger:=0;
//  letzterNachfolger:=0;
  Ebene:=thatEbene;
  Kennung:=thatKennung;
  besucht:=false;
  erreichbar:= false;
  setlength(eta,0);
  setlength(D,0);
  setlength(S,0);
  setlength(delta_eta,0);
//  Showmessage('Neuron erzeugt mit Kennung: '+IntToStr(Kennung));
end;

// Ein Neuron bekommt ein Vorgngerneuron bergeben und sortiert es bei sich ein
procedure Neuron.setVorgaenger(thatNeuron: Neuron; thatGewicht: Real);
begin
SetLength(Vorgaenger, length(Vorgaenger)+1);
SetLength(VorgaengerGewicht, length(Vorgaenger));
SetLength(altesVorgaengerGewicht, length(Vorgaenger));
Vorgaenger[High(Vorgaenger)]:=thatNeuron;
VorgaengerGewicht[High(Vorgaenger)]:=thatGewicht;
altesVorgaengerGewicht[High(Vorgaenger)]:=thatGewicht;
end;

// Das bergebe Neuron wird kein Vorgnger mehr sein
procedure Neuron.delVorgaenger(thatNeuron: Neuron);
var i,j: Integer;
begin
for i:=0 to High(Vorgaenger) do
  begin
    if (Vorgaenger[i]=thatNeuron) then
      begin
        // Element loeschen und Arrayelemente umkopieren
        Vorgaenger[i]:=nil;
          for j:=i to High(Vorgaenger)-1 do
            Vorgaenger[j]:=Vorgaenger[j+1];
        // Zugehrigen Gewichtseintrag anpassen
          for j:=i to High(Vorgaenger)-1 do
            begin
            VorgaengerGewicht[j]:=VorgaengerGewicht[j+1];
            altesVorgaengerGewicht[j]:=altesVorgaengerGewicht[j+1];
            end;
        // Arraygroessen anpassen
        SetLength(Vorgaenger, maximum(Length(Vorgaenger)-1,0));
        SetLength(VorgaengerGewicht, maximum(Length(Vorgaenger),0));
        SetLength(altesVorgaengerGewicht, maximum(Length(Vorgaenger),0));
      end;
  end;
//if Length(Vorgaenger)=0 then destroy; DAS WAR SCHULD FR TAUSEND FEHLER!
end;

// Nachfolgerneuron einsortieren
procedure Neuron.setNachfolger(thatNeuron: Neuron);
begin
//Showmessage('Neuron Nr.: '+IntToStr(getKennung)+' hat als Nachfolger Nr.: '+IntToStr(thatNeuron.getKennung));
SetLength(Nachfolger, Length(Nachfolger)+1);
Nachfolger[High(Nachfolger)]:=thatNeuron;
end;

// ... oder entfernen
procedure Neuron.delNachfolger(thatNeuron: Neuron);
var i,j: integer;
begin
for i:=0 to High(Nachfolger) do
  begin
    if (Nachfolger[i]=thatNeuron) then
      begin
        Nachfolger[i]:=nil;
          for j:=i to High(Nachfolger)-1 do
            Nachfolger[j]:=Nachfolger[j+1];
        SetLength(Nachfolger, Maximum(length(Nachfolger)-1,0));
      end;
  end;
end;

// die Gewichte sind in den Nachfolgern gespeichert und finden sich an der gleichen Arrayposition wie der passende Vorgnger
procedure Neuron.setVorgaengerGewicht(thatGewicht: Real; VorgaengerNeuron: Neuron);
begin
VorgaengerGewicht[getIndexOfVorgaenger(VorgaengerNeuron)]:=thatGewicht;
//Meldungen.app('Neuron Nr '+inttostr(getkennung)+' Vorgaengerindex '+inttostr(getIndexOfVorgaenger(VorgaengerNeuron))+' Gewicht '+floattostr(thatgewicht));
end;

procedure Neuron.setAltesVorgaengerGewicht(thatGewicht: Real; VorgaengerNeuron: Neuron);
begin
altesVorgaengerGewicht[getIndexOfVorgaenger(VorgaengerNeuron)]:=thatGewicht;
end;

procedure Neuron.setBatchVorgaengerGewicht(thatGewicht: Real; VorgaengerNeuron: Neuron);//i
begin
//Showmessage('Von '+inttostr(VorgaengerNeuron.getkennung)+' zu '+inttostr(getkennung)+' Zustzlicher wert '+floattostr(thatgewicht)+' zu '+floattostr(batchVorgaengerGewicht[getIndexOfVorgaenger(VorgaengerNeuron)]));
batchVorgaengerGewicht[getIndexOfVorgaenger(VorgaengerNeuron)]:=batchVorgaengerGewicht[getIndexOfVorgaenger(VorgaengerNeuron)]+thatGewicht;
//showmessage('Ich versuchen nun, von Neuron '+inttostr(getkennung)+' auf das batchVorgaengerGewicht-Array mit Lnge '+inttostr(length(batchVorgaengerGewicht))+' zuzugreifen an position '+inttostr(getIndexOfVorgaenger(VorgaengerNeuron)));
//batchVorgaengerGewicht[getIndexOfVorgaenger(VorgaengerNeuron)]:=thatGewicht;

end;

function Neuron.getBatchVorgaengerGewicht(thatNeuron: Neuron): Real;//i
begin
result:=batchVorgaengerGewicht[getIndexOfVorgaenger(thatNeuron)];
end;

procedure Neuron.setEta(e: Real; VorgaengerNeuron: Neuron);
begin
  eta[getIndexOfVorgaenger(VorgaengerNeuron)]:=e;
end;

function Neuron.getEta(VorgaengerNeuron:Neuron): Real;
begin
  result:=eta[getIndexOfVorgaenger(VorgaengerNeuron)];
end;

procedure Neuron.setBatchSchwellwert(wert: Real);
begin
batchSchwellwert:=batchSchwellwert+wert;
end;

function Neuron.getBatchSchwellwert(): Real;
begin
result:=batchSchwellwert;
end;

function Neuron.getVorgaengerGewicht(i: Integer): Real;
begin
result:=VorgaengerGewicht[i];
end;

// ACHTUNG!
function Neuron.getVorgaengerGewicht(thatNeuron: Neuron): Real;
begin
//meldungen.app('Gefragt wurde nach Vorgaengerindex '+inttostr(getIndexOfVorgaenger(thatNeuron)));
result:=VorgaengerGewicht[getIndexOfVorgaenger(thatNeuron)];
end;

function Neuron.getAltesVorgaengerGewicht(i : Integer): Real;
begin
  result:=altesVorgaengerGewicht[i];
end;

// ACHTUNG!
function Neuron.getAltesVorgaengerGewicht(thatNeuron: Neuron): Real;
begin
result:=altesVorgaengerGewicht[getIndexOfVorgaenger(thatNeuron)];
end;

procedure Neuron.setAlteVorgaengerGewichte();
var i:integer;
begin
  setlength(altesVorgaengerGewicht, length(VorgaengerGewicht));
  for i:=0 to high(altesVorgaengerGewicht) do
    altesVorgaengerGewicht[i] := VorgaengerGewicht[i];
end;



// um das Gewicht anzupassen knnte es ntzlich sein...
function Neuron.getIndexOfVorgaenger(thatNeuron: Neuron): Integer;
var i:Integer;
begin
for i:=0 to High(Vorgaenger) do
  begin
    if Vorgaenger[i]=thatNeuron then
      result:=i;
  end;
end;

function Neuron.berechne():Real;
var
  i: integer;
begin
  if high(Vorgaenger)<>high(vorgaengergewicht) then Showmessage('Gewichts- und Vorgngerarray sind unterschiedlich lang!');
  summe:=0;
  for i:=0 to high(Vorgaenger) do
  begin
    summe:=summe+ Vorgaenger[i].getAusgang * Vorgaengergewicht[i];
//    Meldungen.app(FloatToStr(Summe)+':='+FloatToStr(Summe)+'+'+FloatToStr(Vorgaenger[i].getAusgang)+'*'+FloatToStr(Vorgaengergewicht[i]));
  end;
  summe:=summe-Schwellwert;
  Ausgang:=Funktion.Aufruf(Funktion.Aufruf(summe,AktFkt),AusgFkt);
  // Alle Neuronen geben ihre Daten aus:
  //  Meldungen.app('Neuron Nr. '+IntToStr(Kennung)+' hat die Summe '+FloatToStr(summe)+' und den Ausgang '+FloatToStr(Ausgang));
  // Nur das Ausgabeneuron gibt seine Daten aus:
  if high(Nachfolger)=-1 then result:=Ausgang;
  //Meldungen.app('Neuron Nr. '+IntToStr(Kennung)+' hat die Summe '+FloatToStr(summe)+' und den Ausgang '+FloatToStr(Ausgang));
end;

// HIER FOLGEN NUR NOCH EINFACHE SACHEN
function Neuron.getEbene(): Integer;
begin
result:= Ebene;
end;

procedure Neuron.setEbene(i: Integer);
begin
Ebene:=i;
end;

procedure Neuron.setKennung(thatKennung: Integer);
begin
Kennung:=thatKennung;
end;

function Neuron.getKennung(): Integer;
begin
result:=Kennung;
end;

function Neuron.getVorgaenger(i: Integer): Neuron;
begin
  result:=Vorgaenger[i];
end;

function Neuron.getNachfolger(i: Integer): Neuron;
begin
  result:=Nachfolger[i];
end;

function Neuron.getLetzterVorgaenger(): Integer;
begin
result:= High(Vorgaenger);
end;

function Neuron.getLetzterNachfolger(): Integer;
begin
//Showmessage('Neuron Nr. '+IntToStr(getKennung)+' hat Anzahl Nachfolger: '+inttostr(Length(Nachfolger)));
result:= High(Nachfolger);
end;

function Neuron.getBesucht(): Boolean;
begin
result:=besucht;
end;

procedure Neuron.setBesucht(b: boolean);
begin
besucht:=b;
end;

function Neuron.maximum(i,j:integer):integer;
begin
if i<j then result:=j;
if i>j then result:=i
else result:=i;
end;

function Neuron.getAusgang(): real;
begin
  result:=Ausgang;
end;

function Neuron.getErreichbar: Boolean;
begin
  result:=erreichbar;
end;

procedure Neuron.setErreichbar(b: Boolean);
begin
  erreichbar:=b;
end;

procedure Neuron.setAusgang(a:real);
begin
  Ausgang:=a;
end;

procedure Neuron.setAktFkt(i:integer);
begin
  AktFkt:=i;
//  showmessage('Neuron '+IntToStr(getKennung)+' hat AktFkt '+inttostr(getAktFkt));
end;

procedure Neuron.setAusgFkt(i:integer);
begin
  AusgFkt:=i;
//  showmessage('Neuron '+IntToStr(getKennung)+' hat AusgFkt '+inttostr(getAusgFkt));
end;

function Neuron.getAktFkt():integer;
begin
result:=aktfkt;
end;

function Neuron.getAusgFkt():integer;
begin
result:=ausgfkt;
end;

function Neuron.getSchwellwert(): Real;
begin
result:=Schwellwert;
end;

procedure Neuron.setSchwellwert(r:real);
begin
Schwellwert:=r;
//showmessage('Neuron '+IntToStr(getKennung)+' hat Schwellwert '+Floattostr(getSchwellwert));
end;

function Neuron.istVorgaenger(thatNeuron:Neuron):boolean;
var b:boolean; i: integer;
begin
b:=false;
for i:=0 to High(Vorgaenger) do
  if Vorgaenger[i]=thatNeuron then b:=true;
result:=b;
end;

function Neuron.istNachfolger(thatNeuron:Neuron):boolean;
var b:boolean; i: integer;
begin
b:=false;
for i:=0 to High(Nachfolger) do
  if Nachfolger[i]=thatNeuron then b:=true;
result:=b;
end;

function Neuron.letzteEbeneDerVorgaenger(): integer;
var max,i: Integer;
begin
max:=-3;
for i:=0 to High(Vorgaenger) do
  if max<Vorgaenger[i].getEbene then max:=Vorgaenger[i].getEbene;
result:=max;
end;

function Neuron.getDelta: Real;
begin
  result:=delta;
end;

procedure Neuron.setDelta(r: real);
begin
  delta:=r;
end;

function Neuron.getSumme: Real;
begin
result:=summe;
end;

function Neuron.getAlterSchwellwert: Real;
begin
  result:=alterSchwellwert;
end;


procedure Neuron.setAlterSchwellwert(s: real);
begin
  alterSchwellwert:=s;
end;

procedure Neuron.initBatchVorgaengerGewicht();
var i:integer;
begin
SetLength(batchVorgaengerGewicht, length(VorgaengerGewicht));
//Showmessage('Neuron Nr. '+inttostr(getkennung)+' laenge '+inttostr(length(batchvorgaengergewicht)));
for i:=0 to high(batchvorgaengergewicht) do
  batchVorgaengerGewicht[i]:=0;
batchSchwellwert:=0;
end;

procedure Neuron.batchWerteUebernehmen(x:integer);
var i:Integer;
begin
for i:=0 to high(VorgaengerGewicht) do
  begin
//  showmessage(floattostr(batchvorgaengergewicht[i]));
  Vorgaengergewicht[i]:=batchVorgaengerGewicht[i]/x;
  end;
Schwellwert:=batchSchwellwert/x;
end;

procedure Neuron.setD(w:real;vorgaengerNeuron: Neuron);
begin
  D[getIndexOfVorgaenger(vorgaengerNeuron)]:=w;
end;

function Neuron.getD(vorgaengerNeuron: Neuron): real;
begin
  result:=D[getIndexOfVorgaenger(vorgaengerNeuron)];
end;

procedure Neuron.setS(w:real;vorgaengerNeuron: Neuron);
begin
  S[getIndexOfVorgaenger(vorgaengerNeuron)]:=w;
end;

function Neuron.getS(vorgaengerNeuron: Neuron):real;
begin
  result:=S[getIndexOfVorgaenger(vorgaengerNeuron)];
end;

function Neuron.getDelta_Eta(vorgaengerNeuron: Neuron):real;
begin
  result:=delta_eta[getIndexOfVorgaenger(vorgaengerNeuron)];

end;

procedure Neuron.setDelta_Eta(w:real;vorgaengerNeuron: Neuron);
begin
  delta_eta[getIndexOfVorgaenger(vorgaengerNeuron)]:=w;
end;

function Neuron.getDSchwellwert: real;
begin
result:=DSchwellwert;
end;

procedure Neuron.setDSchwellwert(w:real);
begin
DSchwellwert:=w;
end;

procedure Neuron.setSSchwellwert(w:real);
begin
SSchwellwert:=w;
end;

function Neuron.getSSchwellwert:real;
begin
result:=SSchwellwert;
end;

procedure Neuron.setetaSchwellwert(w:real);
begin
etaSchwellwert:=w;
end;

function Neuron.getetaSchwellwert:real;
begin
result:=etaSchwellwert;
end;

procedure Neuron.setdelta_etaSchwellwert(w:real);
begin
delta_etaSchwellwert:=w;
end;

function Neuron.getdelta_etaSchwellwert:real;
begin
result:=delta_etaSchwellwert;
end;


procedure Neuron.initdbd(starteta:real);
var i:integer;
begin
  //eta:
  setlength(eta, length(Vorgaenger));
  for i:=0 to high(eta) do
    eta[i]:=starteta;
  // delta_eta:
  setlength(delta_eta, length(Vorgaenger));
  for i:=0 to high(delta_eta) do
    delta_eta[i]:=0;
  // S:
  setlength(S, length(Vorgaenger));
  for i:=0 to high(S) do
    S[i]:=0;
  // D:
  setlength(D, length(Vorgaenger));
  for i:=0 to high(D) do
    D[i]:=0;

    DSchwellwert:=0;
    SSchwellwert:=0;
    etaSchwellwert:=starteta;
    delta_etaSchwellwert:=0;
end;



end.
